Package com.sun.mail.util

# Class QDecoderStream

java.lang.Object
java.io.InputStream
java.io.FilterInputStream
com.sun.mail.util.QPDecoderStream
com.sun.mail.util.QDecoderStream

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`

public class QDecoderStream extends QPDecoderStream
This class implements a Q Decoder as defined in RFC 2047 for decoding MIME headers. It subclasses the QPDecoderStream class.

Author:
  John Mani

## Field Summary

### Fields inherited from class com.sun.mail.util.QPDecoderStream

`ba, spaces`

### Fields inherited from class java.io.FilterInputStream

`in`

## Constructor Summary

Constructors
Constructor
Description
`QDecoderStream(InputStream in)`
Create a Q-decoder that decodes the specified input stream.

## Method Summary

Modifier and Type
Method
Description
`int`
`read()`
Read the next decoded byte from this input stream.

### Methods inherited from class com.sun.mail.util.QPDecoderStream

`available, markSupported, read, skip`

### Methods inherited from class java.io.FilterInputStream

`close, mark, read, reset`

### Methods inherited from class java.io.InputStream

`nullInputStream, readAllBytes, readNBytes, readNBytes, skipNBytes, transferTo`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### QDecoderStream

public QDecoderStream(InputStream in)
Create a Q-decoder that decodes the specified input stream.

Parameters:
  `in` - the input stream

## Method Details

### read

public int read() throws IOException
Read the next decoded byte from this input stream. The byte is returned as an `int` in the range `0` to `255`. If no byte is available because the end of the stream has been reached, the value `-1` is returned. This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

Overrides:
  `read` in class `QPDecoderStream`
Returns:
  the next byte of data, or `-1` if the end of the stream is reached.
Throws:
  `IOException` - if an I/O error occurs.